{-# OPTIONS -fffi -fglasgow-exts #-}

-- export an interface to the fmindex for Haskell 

module Main where
-- module FMIndex where

import Foreign
import Foreign.C.Types
import Foreign.C.String


main = do 
        t <- readFile "/Home/stip/ketil/data/b10000-masked.seq"
        print "t!"
        i <- buildIndex t
        print "i!"
        c1 <- countIO i "\n"
        print c1
        t2 <- extractIO i (1,10)
        print t2
        let c = count i "\n"
        print c
        c <- countIO i ">"
        print c


data FMIndex

-- --------------------------------------------------
--  int build_index(uchar *text, ulong length, char *build_options
--                 , void **index);

foreign import ccall "interface.h build_index" build_index
  :: CString -> CULong -> CString -> Ptr (Ptr FMIndex) -> IO CInt

foreign import ccall "ds_ssort.h init_ds_ssort" init_ds_ssort
  :: CInt -> CInt -> IO CInt

fmbopts :: CString
fmbopts = unsafePerformIO $ newCString "-a 2"-- nullPtr 

buildIndexC :: CStringLen -> IO (Ptr FMIndex)
buildIndexC (str,len) = alloca $ \ptr -> do
                   rc <- build_index str (fromIntegral len) fmbopts ptr
                   if rc < 0 then error "build_index bugged out"
                             else peek ptr

buildIndex :: String -> IO (Ptr FMIndex)
buildIndex s = withCStringLen s buildIndexC

-- --------------------------------------------------
--  int count(void *index, uchar *pattern, ulong length
--           , ulong *numocc);

foreign import ccall "interface.h count" fm_count
  :: Ptr FMIndex -> CString -> CULong -> Ptr CULong -> Int

-- This is basically a pure fuction, so using IO sucks
countIO :: Ptr FMIndex -> String -> IO Int
countIO i s = withCStringLen s $ \(str,len) -> 
              alloca $ \ptr -> do
                let rc = fm_count i str (fromIntegral len) ptr
                if rc < 0 then error "count bugged out"
                          else peek ptr >>= return . fromIntegral

count :: Ptr FMIndex -> String -> Int
count i = unsafePerformIO . countIO i

-- --------------------------------------------------
--  int locate(void *index, uchar *pattern, ulong length
--            , ulong **occ, ulong *numocc);

foreign import ccall "interface.h locate" fm_locate
  :: Ptr FMIndex -> CString -> CULong -> Ptr (Ptr CULong) -> Ptr CULong

locateIO :: Ptr FMIndex -> String -> IO [Int]
locateIO = undefined

locate :: Ptr FMIndex -> String -> [Int]
locate i = unsafePerformIO . locateIO i

-- --------------------------------------------------
--  int extract(void *index, ulong from, ulong to, uchar **snippet
--             , ulong *snippet_length);

foreign import ccall "interface.h extract" fm_extract
  :: Ptr FMIndex -> CULong -> CULong -> Ptr CString -> Ptr CULong -> Int

extractIO :: Ptr FMIndex -> (Int,Int) -> IO String
extractIO i (beg,end) = alloca $ \snipptr -> 
                        alloca $ \sniplen -> do
                            let rc = fm_extract i (fromIntegral beg) (fromIntegral end) snipptr sniplen
                            if rc < 0 then error "extractIO bugged out"
                                      else peek snipptr >>= peekCString 

extract :: Ptr FMIndex -> (Int,Int) -> String
extract i = unsafePerformIO . extractIO i
